## open-iscsi 2.1.5

=== libopeniscsiusr/Makefile ===
# Makefile
#
# Copyright (C) 2017 Red Hat, Inc.
# Gris Ge <fge@redhat.com>
#

ifeq ($(TOPDIR),)
	TOPDIR = ..
endif

DESTDIR ?=
prefix ?= /usr
INSTALL ?= install

ifndef LIB_DIR
	ifeq ($(shell test -d /lib64 && echo 1),1)
		LIB_DIR=$(prefix)/lib64
	else
		LIB_DIR=$(prefix)/lib
	endif
endif

INCLUDE_DIR ?= $(prefix)/include
PKGCONF_DIR ?= $(LIB_DIR)/pkgconfig

PKG_CONFIG = /usr/bin/pkg-config

LIBISCSI_USR_DIR=$(TOPDIR)/libopeniscsiusr

LIBISCSI_USR_VERSION_MAJOR=0
LIBISCSI_USR_VERSION=0.2.0
SONAME=$(LIBISCSI_USR_VERSION)
DEVLIB = libopeniscsiusr.so
LIBS = $(DEVLIB).$(SONAME)
LIBS_MAJOR = $(DEVLIB).$(LIBISCSI_USR_VERSION_MAJOR)
PKGFILE = libopeniscsiusr.pc
HEADERS = libopeniscsiusr/libopeniscsiusr.h \
	  libopeniscsiusr/libopeniscsiusr_common.h \
	  libopeniscsiusr/libopeniscsiusr_session.h \
	  libopeniscsiusr/libopeniscsiusr_iface.h \
	  libopeniscsiusr/libopeniscsiusr_node.h
TESTS = tests/test_context tests/test_session tests/test_iface tests/test_node
EXTRA_MAN_FILES = libopeniscsiusr.h.3

OBJS = context.o misc.o session.o sysfs.o iface.o idbm.o node.o default.o

CFLAGS ?= -O2 -g
CFLAGS += -Wall -Werror -Wextra -fvisibility=hidden -fPIC
CFLAGS += $(shell $(PKG_CONFIG) --cflags libkmod)

LDFLAGS += $(shell $(PKG_CONFIG) --libs libkmod)

LIBADD =

all: $(LIBS) $(LIBS_MAJOR) $(TESTS) doc

$(LIBS): $(OBJS)
	@echo CFLAGS= $(CFLAGS)
	$(CC) $(CFLAGS) -shared -Wl,-soname=$@ -o $@ $(OBJS) $(LDFLAGS) $(LIBADD)
	ln -sf $@ $(DEVLIB)

$(LIBS_MAJOR): $(LIBS)
	ln -sf $(LIBS) $@

clean:
	$(RM) vgcore* core *.a *.o *.gz *.so *.so.* $(TESTS)
	$(RM) -r docs/man

$(TESTS): $(LIBS)
$(TESTS): CFLAGS += -I$(TOPDIR)/libopeniscsiusr -g
$(TESTS): LDFLAGS += $(LIBADD) -L$(TOPDIR)/libopeniscsiusr -lopeniscsiusr

check: $(LIBS) $(TESTS)
	sudo env LD_LIBRARY_PATH=$(LIBISCSI_USR_DIR) TESTS="$(TESTS)" \
		tests/runtest.sh || exit 1;

install: $(LIBS) $(LIBS_MAJOR)
	$(INSTALL) -d $(DESTDIR)/$(LIB_DIR)/
	$(INSTALL) -d $(DESTDIR)/$(INCLUDE_DIR)/
	$(INSTALL) $(LIBS) $(DESTDIR)$(LIB_DIR)/
	ln -sf $(LIBS) $(DESTDIR)/$(LIB_DIR)/$(DEVLIB)
	ln -sf $(LIBS) $(DESTDIR)/$(LIB_DIR)/$(LIBS_MAJOR)
	$(INSTALL) $(HEADERS) $(DESTDIR)$(INCLUDE_DIR)/
	$(INSTALL) -m 644 -D $(PKGFILE).in $(DESTDIR)$(PKGCONF_DIR)/$(PKGFILE)
	perl -i -pe 's|__VERSION__|$(LIBNVME_VERSION)|g' \
		$(DESTDIR)$(PKGCONF_DIR)/$(PKGFILE)
	perl -i -pe 's|__LIB_DIR__|$(LIB_DIR)|g' \
		$(DESTDIR)$(PKGCONF_DIR)/$(PKGFILE)
	perl -i -pe 's|__INCLUDE_DIR__|$(INCLUDE_DIR)|g' \
		$(DESTDIR)$(PKGCONF_DIR)/$(PKGFILE)

doc: docs/man/$(EXTRA_MAN_FILES).gz

TEMPFILE := $(shell mktemp)

docs/man/$(EXTRA_MAN_FILES).gz: $(HEADERS)
	@for file in $(EXTRA_MAN_FILES); do \
		$(INSTALL) -v -m 644 -D docs/$$file docs/man/$$file; \
	done
	cat $(HEADERS) | \
	    perl docs/doc-preclean.pl > "$(TEMPFILE)"
	perl docs/kernel-doc -man "$(TEMPFILE)" | \
	    perl docs/split-man.pl docs/man
	-rm -f "$(TEMPFILE)"
	@for file in docs/man/*.3; do \
		gzip -f $$file; \
	done
	find docs/man -type f -name \*[0-9].gz

=== usr/Makefile ===
# This Makefile will work only with GNU make.

ifeq ($(TOPDIR),)
	TOPDIR = ..
endif

OSNAME=$(shell uname -s)

# allow users to override these
# eg to compile for a kernel that you aren't currently running
KERNELRELEASE ?= $(shell uname -r)
KSRC ?= /lib/modules/$(KERNELRELEASE)/build

KSUBLEVEL=$(shell cat $(KSRC)/Makefile | awk -F= '/^SUBLEVEL =/ {print $$2}' | \
			sed 's/^[ \t]*//;s/[ \t]*$$//')

ifeq ($(OSNAME),Linux)
	ifeq ($(KSUBLEVEL),11)
		IPC_CFLAGS=-DNETLINK_ISCSI=12 -D_GNU_SOURCE
	else
	ifeq ($(KSUBLEVEL),12)
		IPC_CFLAGS=-DNETLINK_ISCSI=12 -D_GNU_SOURCE
	else
		IPC_CFLAGS=-DNETLINK_ISCSI=8 -D_GNU_SOURCE
	endif
	endif
IPC_OBJ=netlink.o
else
ifeq ($(OSNAME),FreeBSD)
IPC_CFLAGS=
IPC_OBJ=ioctl.o
endif
endif

PKG_CONFIG = /usr/bin/pkg-config

CFLAGS ?= -O2 -g
WARNFLAGS ?= -Wall -Wextra -Werror -Wstrict-prototypes -fno-common
CFLAGS += $(WARNFLAGS) -I../include -I. -D_GNU_SOURCE \
	  -I$(TOPDIR)/libopeniscsiusr
CFLAGS += $(shell $(PKG_CONFIG) --cflags libkmod)
ISCSI_LIB = -L$(TOPDIR)/libopeniscsiusr -lopeniscsiusr
LDFLAGS += $(shell $(PKG_CONFIG) --libs libkmod)
ifeq ($(NO_SYSTEMD),)
LDFLAGS += $(shell $(PKG_CONFIG) --libs libsystemd)
else
CFLAGS += -DNO_SYSTEMD
endif
PROGRAMS = iscsid iscsiadm iscsistart

# libc compat files
SYSDEPS_SRCS = $(sort $(wildcard ../utils/sysdeps/*.o))
# sources shared between iscsid, iscsiadm and iscsistart
ISCSI_LIB_SRCS = iscsi_util.o io.o auth.o iscsi_timer.o login.o log.o \
	iface.o idbm.o sysfs.o host.o session_info.o iscsi_sysfs.o \
	iscsi_net_util.o iscsid_req.o transport.o iser.o cxgbi.o be2iscsi.o \
	initiator_common.o iscsi_err.o flashnode.o uip_mgmt_ipc.o \
	netlink.o $(SYSDEPS_SRCS)
# core initiator files
INITIATOR_SRCS = initiator.o scsi.o actor.o event_poll.o mgmt_ipc.o kern_err_table.o

# fw boot files
FW_BOOT_SRCS = $(sort $(wildcard ../utils/fwparam_ibft/*.o))

# core discovery files
DISCOVERY_SRCS = $(FW_BOOT_SRCS) local_strings.o discovery.o

all: $(PROGRAMS)

iscsid: $(ISCSI_LIB_SRCS) $(INITIATOR_SRCS) $(DISCOVERY_SRCS) \
	iscsid.o session_mgmt.o discoveryd.o mntcheck.o
	$(CC) $(CFLAGS) $^ -o $@  -lisns -lcrypto -lrt -lmount $(LDFLAGS) $(ISCSI_LIB)

iscsiadm: $(ISCSI_LIB_SRCS) $(DISCOVERY_SRCS) iscsiadm.o session_mgmt.o mntcheck.o
	$(CC) $(CFLAGS) $^ -o $@ -lisns -lcrypto -lmount $(LDFLAGS) $(ISCSI_LIB)

iscsistart: $(ISCSI_LIB_SRCS) $(INITIATOR_SRCS) $(FW_BOOT_SRCS) \
		iscsistart.o statics.o
	$(CC) $(CFLAGS) $^ -o $@ -lcrypto -lrt $(LDFLAGS) $(ISCSI_LIB)
clean:
	rm -f *.o $(PROGRAMS) .depend $(LIBSYS)

depend:
	gcc $(CFLAGS) -M `ls *.c` > .depend

-include .depend

=== utils/fwparam_ibft/Makefile ===
#
#  Copyright (C) IBM Corporation. 2007
#  Author: Doug Maxey <dwm@austin.ibm.com>
#
#  This program is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
#  Authors: Patrick Mansfield <patmans@us.ibm.com>
#	    Mike Anderson <andmike@us.ibm.com>
#	    Doug Maxey <dwm@austin.ibm.com>
#	    "Prasanna Mumbai" <mumbai.prasanna@gmail.com>
#
ifeq ($(TOPDIR),)
	TOPDIR = ../..
endif


SYSDEPS_OBJS = $(sort $(wildcard ../sysdeps/*.o))
OBJS := fw_entry.o fwparam_sysfs.o $(SYSDEPS_OBJS) \
	$(TOPDIR)/usr/iscsi_net_util.o
OBJS += prom_lex.o prom_parse.tab.o fwparam_ppc.o
CLEANFILES = $(OBJS) *.output *~

CFLAGS ?= -O2 -g
WARNFLAGS ?= -Wall -Wstrict-prototypes -Wno-format-truncation
CFLAGS += -fPIC $(WARNFLAGS) -I$(TOPDIR)/include -I$(TOPDIR)/usr -D_GNU_SOURCE \
	  -I$(TOPDIR)/libopeniscsiusr

LDFLAGS += -L$(TOPDIR)/libopeniscsiusr -liscsiusr

all: $(OBJS)

clean:
	rm -f *.o $(CLEANFILES) .depend

$(OBJS): prom_parse.tab.h prom_parse.h fwparam_ibft.h

depend:
	gcc $(CFLAGS) -M `ls *.c` > .depend

-include .depend

=== debian/changelog ===
open-iscsi (2.1.5-1ubuntu1.1) jammy; urgency=medium

  * IPv6 support for iBFT iSCSI boot (LP: #2097808)
    - d/p/lp2097808-IPv6-support-for-iBFT-iSCSI-boot-493.patch

 -- Chengen Du <chengen.du@canonical.com>  Tue, 11 Feb 2025 03:06:32 +0000

open-iscsi (2.1.5-1ubuntu1) jammy; urgency=medium

  * Merge with Debian unstable (LP: #1946835). Remaining changes:
    - debian/tests: Add Ubuntu autopkgtest suite:
      + d/t/README-boot-test.md: document test design
      + d/t/control: register testsuite
      + d/t/get-image: helper to fetch an ubuntu cloud image
      + d/t/patch-image: helper to modify an ubuntu cloud image
      + d/test-open-iscsi.py, d/t/testlib.py: various qa regression tests
      + d/t/testsuite: helper to invoke qa regression tests
      + d/t/tgt-boot-test: test using tgt to boot from iscsi
      + d/t/xkvm: helper to spawn a VM
    - Stop producing udebs on i386 where we no longer have d-i or a kernel.
    - d/README.Debian, d/extra/startup-checks.sh, d/open-iscsi-udeb.start,
      d/open-iscsi.postinst: Apply Ubuntu branding to iqn initiator name
    - d/control: Transition from libopeniscsiusr0.2.0 to libopeniscsiusr
    - d/t/test-open-iscsi.py: adopt to resolvectl (systemd v249 compat)
  * Dropped changes, included in Debian:
    - d/iscsid.service: Let iscsid systemd job run in privileged containers
      but not in unprivileged ones
    - debian/extra/initramfs.local-top: handle iSCSI iBFT DHCP to correctly
      run ipconfig to gather all DHCP config info, including DNS search
      domain, which iBFT can't provide.
    - Remove initramfs interfaces stamp in case no iscsi devs mounted
      If iscsi root was requested, but no iscsi devices were mounted, remove
      the initramfs interfaces stamp file. Meaning, that on shutdown there is
      no 30s delay, whilst trying to re-establish iscsi login to perform a
      logout.
    - add IPv6 support
      + Source /run/net6-*.conf when needed.
      + debian/extra/initramfs.local-top: handle IPv6 configs being shipped
        in DEVICE6 or /run/net6-*.conf in the initramfs, so we can fill in
        /run/initramfs/open-iscsi.interface
    - d/rules, d/open-iscsi.finalrd, d/control: ship the finalrd iscsi
      logout hook and recommend finalrd and busybox for the logout hook
      to work.
    - Make iscsid socket-activated to only activate it as needed:
      + debian/open-iscsi.service: do not start or check iscsid.service
      + debian/rules: install and enable iscsid.socket
      + debian/open-iscsi.postinst:
        + run restart logic only if service is running on upgrade
        + drop no longer reachable upgrade path that affects iscsid
        + disable iscsid.service on upgrade
        + handle iscsid.socket to be started if the service is not running yet
      + d/iscsi-disk.rules: Add a udev rule so that iscsid.service will be
        run when udev disks are attached.
      + d/iscsid.service: Remove ExecStop= directive.
      + debian/tests/install: fix tests to work with socket activation
      + debian/patches/lp1755858-default-iscsid_conf-to-iscsid_socket.patch
    - debian/open-iscsi.service: Start open-iscsi systemd job when either
      /etc/iscsi/nodes or /sys/class/iscsi_session have content.
    - Prevent network interface that contains iscsi root from bouncing
      during boot or going down during shutdown if the system is using
      resolvconf or ifupdown:
      + d/iscsi-network-interface.rules
      + d/extra/net-interface-handler
    - debian/extra/initramfs.hook: add ib_iser to the list of modules
      included in the initramfs, so that we can in principle support
      iscsi root on infiniband.
    - debian/open-iscsi.kmod drop: (LP 1833586)
      no static module list is needed if we let iscsid load modules itself.
    - d/extra/initramfs.local-{top,bottom}: move removal of
      open-iscsi.interface file from local-top to local-bottom,
      and fix shell quoting issue that would result in /run/initramfs/
      open-iscsi.interface always being removed (LP 1872813)
    - d/rules: Don't FTBFS due to warnings new in gcc10 regarding bounds and
      initialization, because upstream's gcc10 support is incomplete. This
      change can be dropped when upstream has completed their gcc support.
  * Added changes
    - d/rules: remove duplicated dh_installsystemd section

 -- Dave Jones <dave.jones@canonical.com>  Wed, 19 Jan 2022 11:38:12 +0000

open-iscsi (2.1.5-1) unstable; urgency=medium

  * [150470c] New upstream version 2.1.5
  * [7ca9f9e] Install the debian iscsid.service unit (Closes: #996708)
  * [d660992] Add patch to fix build failure with gcc-11

 -- Ritesh Raj Sarraf <rrs@debian.org>  Thu, 21 Oct 2021 21:36:50 +0530

open-iscsi (2.1.4-2) unstable; urgency=low

  [ Debian Janitor ]
  * [66832cc] Trim trailing whitespace.
  * [f68aaaf] debian/copyright: use spaces rather than tabs to start
    continuation lines.
  * [16eb556] Use secure URI in Homepage field.
  * [c3f9946] Bump debhelper dependency to >= 10, since that's what
    is used in debian/compat.
  * [693da74] Bump debhelper from old 10 to 13.
    + Use dh_installsystemd rather than deprecated dh_systemd_enable.
    + Use dh_installsystemd rather than deprecated dh_systemd_start.
    + debian/rules: Drop --fail-missing argument to dh_missing, which
      is now the default.
  * [107b3e4] Set debhelper-compat version in Build-Depends.
  * [68b97c5] Remove unnecessary 'Testsuite: autopkgtest' header.
  * [b80b61e] Set upstream metadata fields: Bug-Database, Bug-Submit,
    Repository, Repository-Browse.
  * [1096e5b] Update standards version to 4.5.1, no changes needed.

 -- Ritesh Raj Sarraf <rrs@debian.org>  Thu, 09 Sep 2021 19:36:42 +0530

open-iscsi (2.1.4-1) unstable; urgency=low

  [ Ritesh Raj Sarraf ]
  * [1a58d4e] Drop patches. Part of new upstream release
  * [a264531] Rebase patch

  [ Rafael David Tinoco ]
  * d/iscsid.service: Let iscsid systemd job run in privileged


=== debian/rules ===
#!/usr/bin/make -f
# export DH_VERBOSE = 1

DEB_HOST_MULTIARCH  ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

include /usr/share/dpkg/pkg-info.mk
export KBUILD_BUILD_TIMESTAMP = @$(SOURCE_DATE_EPOCH)

UDEB := $(filter open-iscsi-udeb,$(shell dh_listpackages))

# Fix gcc10 warnings as errors while upstream doesn't catch up
export DEB_CFLAGS_PREPEND=-Wno-error=zero-length-bounds -Wno-error=format-overflow= -Wno-error=format-truncation= -Wno-error=maybe-uninitialized
export DEB_CXXFLAGS_PREPEND=${DEB_CFLAGS_PREPEND}

%:
	dh $@

override_dh_update_autotools_config:
override_autoreconf:
override_dh_auto_configure:

override_dh_auto_build:
	@# Let debhelper pass configure flags.
	dh_auto_configure --sourcedirectory=iscsiuio

	CFLAGS="$(CPPFLAGS) $(CFLAGS)" dh_auto_build

override_dh_auto_install:

	@# libopeniscsiusr
	dh_install -p libopeniscsiusr libopeniscsiusr/libopeniscsiusr*.so.* usr/lib/${DEB_HOST_MULTIARCH}

	@# libopeniscsi-dev
	dh_install -p libopeniscsiusr-dev libopeniscsiusr/libopeniscsiusr/ usr/include/

	@# open-iscsi
	dh_install -p open-iscsi usr/iscsid sbin/
	dh_install -p open-iscsi usr/iscsistart sbin/
	dh_install -p open-iscsi usr/iscsiadm sbin/
	dh_install -p open-iscsi utils/iscsi_discovery sbin/
	dh_install -p open-iscsi utils/iscsi-iname sbin/
	dh_install -p open-iscsi etc/iscsid.conf etc/iscsi/
	dh_install -p open-iscsi debian/extra/umountiscsi.sh lib/open-iscsi/
	dh_install -p open-iscsi debian/extra/logout-all.sh lib/open-iscsi/
	dh_install -p open-iscsi debian/extra/startup-checks.sh lib/open-iscsi/
	dh_install -p open-iscsi debian/extra/activate-storage.sh lib/open-iscsi/
	dh_install -p open-iscsi debian/extra/net-interface-handler lib/open-iscsi/
	dh_install -p open-iscsi debian/open-iscsi.finalrd usr/share/finalrd/
	dh_install -p open-iscsi etc/systemd/iscsid.socket lib/systemd/system/
	dh_install -p open-iscsi debian/iscsid.service lib/systemd/system/
	mkdir -p debian/open-iscsi/usr/bin
	ln -s /sbin/iscsiadm debian/open-iscsi/usr/bin/iscsiadm
	mkdir -p debian/open-iscsi/usr/share/initramfs-tools/hooks
	mkdir -p debian/open-iscsi/usr/share/initramfs-tools/scripts/local-top/
	mkdir -p debian/open-iscsi/usr/share/initramfs-tools/scripts/local-bottom/
	cp -p debian/extra/initramfs.hook debian/open-iscsi/usr/share/initramfs-tools/hooks/iscsi
	cp -p debian/extra/initramfs.local-top debian/open-iscsi/usr/share/initramfs-tools/scripts/local-top/iscsi
	cp -p debian/extra/initramfs.local-bottom debian/open-iscsi/usr/share/initramfs-tools/scripts/local-bottom/iscsi
	mkdir -p debian/open-iscsi/lib/udev/rules.d/
	cp -p debian/open-iscsi.rules debian/open-iscsi/lib/udev/rules.d/70-open-iscsi.rules
	cp -p debian/iscsi-network-interface.rules debian/open-iscsi/lib/udev/rules.d/70-iscsi-network-interface.rules

	@# iscsiuio
	dh_install -p iscsiuio iscsiuio/src/unix/iscsiuio /sbin
	mkdir -p debian/iscsiuio/usr/share/initramfs-tools/hooks
	cp -p debian/extra/iscsiuio.initramfs.hook debian/iscsiuio/usr/share/initramfs-tools/hooks/iscsiuio

ifneq ($(UDEB),)
	@# open-iscsi-udeb
	dh_install -p open-iscsi-udeb usr/iscsid sbin/
	dh_install -p open-iscsi-udeb usr/iscsistart sbin/
	dh_install -p open-iscsi-udeb usr/iscsiadm sbin/
	dh_install -p open-iscsi-udeb utils/iscsi_discovery sbin/
	dh_install -p open-iscsi-udeb utils/iscsi-iname sbin/
	dh_install -p open-iscsi-udeb etc/iscsid.conf etc/iscsi/
	dh_install -p open-iscsi-udeb debian/open-iscsi-udeb.start sbin/iscsi-start
	dh_install -p open-iscsi-udeb debian/open-iscsi-udeb.finish-install usr/lib/finish-install.d/10open-iscsi

	# Ship shared libraries along with the executable in a single udeb
	dh_install -p open-iscsi-udeb libopeniscsiusr/libopeniscsiusr*.so.* usr/lib/${DEB_HOST_MULTIARCH}
endif

override_dh_installinit:
	dh_installinit -p open-iscsi --no-start --no-enable --no-stop-on-upgrade --name=iscsid
	dh_installinit -p open-iscsi --no-start --no-enable --no-stop-on-upgrade
	dh_installinit -p iscsiuio --no-start --no-enable --no-stop-on-upgrade

override_dh_installsystemd:
	dh_installsystemd -p open-iscsi --name=iscsid --no-enable --no-stop-on-upgrade iscsid.service
	dh_installsystemd -p open-iscsi --name=iscsid --no-stop-on-upgrade iscsid.socket
	dh_installsystemd -p open-iscsi --no-stop-on-upgrade open-iscsi.service
	dh_installsystemd -p iscsiuio --no-stop-on-upgrade iscsiuio.service

override_dh_installman:
	dh_installman -p open-iscsi ./doc/*
	dh_installman -p libopeniscsiusr-dev ./libopeniscsiusr/docs/man/*
	dh_installman -p iscsiuio iscsiuio/docs/*

override_dh_installdocs:
	dh_installdocs -p open-iscsi README sysfs-documentation THANKS
	dh_installdocs -p iscsiuio iscsiuio/RELEASE.TXT iscsiuio/README
	dh_installdocs -p libopeniscsiusr ./libopeniscsiusr/docs/doc-preclean.pl ./libopeniscsiusr/docs/kernel-doc ./libopeniscsiusr/docs/libopeniscsiusr.h.3 ./libopeniscsiusr/docs/split-man.pl
	dh_installdocs -p libopeniscsiusr-dev

override_dh_makeshlibs:
ifneq ($(UDEB),)
	dh_makeshlibs --add-udeb=open-iscsi-udeb
else
	dh_makeshlibs
endif

# The following is taken from the initramfs-tools package. (We recommend
# busybox in the initramfs because otherwise we don't have access to the
# ip utility to set the default gateway after iscsistart -N is done.)
# On Debian we can use either busybox or busybox-static, but on Ubuntu
# and derivatives only busybox-initramfs will work.
BUSYBOX_PACKAGES := $(shell if dpkg-vendor --derives-from ubuntu; then echo busybox-initramfs; else echo busybox busybox-static; fi)

override_dh_gencontrol:
	echo >> debian/open-iscsi.substvars "busybox:Recommends=$(wordlist 2,100,$(BUSYBOX_PACKAGES:%=| %))"
	dh_gencontrol

=== debian/tests/control ===
Tests: install
Restrictions: needs-root, isolation-machine, breaks-testbed

Tests: testsuite
Restrictions: needs-root isolation-machine breaks-testbed
Depends: open-iscsi, python3, tgt, qemu-system, ubuntu-cloudimage-keyring, simplestreams, python3-netifaces, distro-info, cloud-image-utils, dctrl-tools, rsync

Tests: nested
Restrictions: needs-root, isolation-machine, breaks-testbed, allow-stderr
Depends: targetcli-fb, qemu-system, qemu-utils, python3, python3-netifaces

## open-iscsi 2.1.7

=== debian/changelog ===
open-iscsi (2.1.7-2ubuntu1) kinetic; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - debian/tests: Add Ubuntu autopkgtest suite:
      + d/t/README-boot-test.md: document test design
      + d/t/control: register testsuite
      + d/t/get-image: helper to fetch an ubuntu cloud image
      + d/t/patch-image: helper to modify an ubuntu cloud image
      + d/test-open-iscsi.py, d/t/testlib.py: various qa regression tests
      + d/t/testsuite: helper to invoke qa regression tests
      + d/t/tgt-boot-test: test using tgt to boot from iscsi
      + d/t/xkvm: helper to spawn a VM
    - d/README.Debian, d/extra/startup-checks.sh, d/open-iscsi.postinst:
      Apply Ubuntu branding to iqn initiator name
  * Dropped changes, no longer needed:
    - debian/open-iscsi-udeb.start: Apply Ubuntu branding
    - Stop producing udebs on i386 where we no longer have d-i or a kernel.
  * Dropped changes, included in Debian:
    - d/p/lp1979692-fix-gcc12-ftbfs-0*.patch: Fix FTBFS with GCC 12.
    - d/rules: remove duplicated dh_installsystemd section
  * Dropped changes, no longer needed:
    - d/control: Transition from libopeniscsiusr0.2.0 to libopeniscsiusr;
      not needed, the referenced version is no longer in any supported
      release and the transitional package is in the previous LTS.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 16 Aug 2022 08:32:36 -0700

open-iscsi (2.1.7-2) unstable; urgency=medium

  * [09dfaec] Enable hardening build flags
  * [c0ce256] d/rules: remove unused DEB_HOST_MULTIARCH
  * [70574d1] Run separate build for udeb to avoid libsystemd dependency
    (Closes: #1003366)

 -- Chris Hofstaedtler <zeha@debian.org>  Sat, 30 Jul 2022 14:23:25 +0000

open-iscsi (2.1.7-1) unstable; urgency=medium

  * [3050096] New upstream version 2.1.7 (Closes: #982307, #1016246)
  * [46fd279] Refresh patches, drop upstream applied ftbfs patch
  * [cac01da] Help upstream Makefile find sed in /bin
  * [0202184] Add patches from upstream master to fix build
  * [f61e6a0] Use dh_auto_install, better suits new upstream build system
  * [2080bfb] Fix multiarch install location
  * [4f57eb7] Move udeb files into correct places (like in 2.0.874-7.1)
  * [75b86ce] Cleanup duplicate override_dh_installsystemd section
    (Closes: #1004014)
  * [24f9981] d/copyright: update
  * [41970e3] Rely on dh_installinitramfs to install triggers

 -- Chris Hofstaedtler <zeha@debian.org>  Fri, 29 Jul 2022 19:59:11 +0000

open-iscsi (2.1.5-1ubuntu2) kinetic; urgency=medium

  * d/p/lp1979692-fix-gcc12-ftbfs-0*.patch: Fix FTBFS with GCC 12.
    (LP: #1979692)

 -- Sergio Durigan Junior <sergio.durigan@canonical.com>  Thu, 23 Jun 2022 17:28:56 -0400

## open-iscsi 2.1.8

=== Makefile ===
#
# Makefile for the Open-iSCSI Initiator
#

# if you are packaging open-iscsi, set this variable to the location
# that you want everything installed into.
DESTDIR ?=

# our VERSION String
ISCSI_VERSION_STR ?= 2.1.8

prefix = /usr
exec_prefix =
mandir = $(prefix)/share/man
etcdir = /etc

SBINDIR = $(exec_prefix)/sbin
HOMEDIR = $(etcdir)/iscsi
DBROOT = $(etcdir)/iscsi
RULESDIR = $(etcdir)/udev/rules.d

INSTALL = /usr/bin/install

# pass these on to sub-Makefiles
export DESTDIR prefix INSTALL SBINDIR HOMEDIR DBROOT RULESDIR ISCSI_VERSION_STR

# Compatibility: parse old OPTFLAGS argument
ifdef OPTFLAGS
CFLAGS = $(OPTFLAGS)
endif

# Export it so configure of iscsiuio will
# pick it up.
ifneq (,$(CFLAGS))
export CFLAGS
endif

# export systemd disablement if set
ifneq ($(NO_SYSTEMD),)
export NO_SYSTEMD
WITHOUT_ARG = --without-systemd
else
WITHOUT_ARG =
endif

# Random comments:
# using '$(MAKE)' instead of just 'make' allows make to run in parallel
# over multiple makefile.

all: user

make_utils:
	$(MAKE) $(MFLAGS) -C utils

deprecation_msg:
	@echo "***"
	@echo "*** Warning: using 'make' is being deprecated, in favor of 'meson'"
	@echo "***    Please see the README file for more information."
	@echo "***"

user: deprecation_msg iscsiuio/Makefile
	$(MAKE) $(MFLAGS) -C libopeniscsiusr
	$(MAKE) $(MFLAGS) -C sysdeps
	$(MAKE) $(MFLAGS) -C usr
	$(MAKE) $(MFLAGS) -C utils
	$(MAKE) $(MFLAGS) -C etc
	$(MAKE) $(MFLAGS) -C iscsiuio
	$(MAKE) $(MFLAGS) -C doc
	@echo
	@echo "Compilation complete                 Output file"
	@echo "-----------------------------------  ----------------"
	@echo "Built iSCSI daemon:                  usr/iscsid"
	@echo "Built management application:        usr/iscsiadm"
	@echo "Built boot tool:                     usr/iscsistart"
	@echo "Built iscsiuio daemon:               iscsiuio/src/unix/iscsiuio"
	@echo "Built libopeniscsiusr library:       libopeniscsiusr/libopeniscsiusr.so"
	@echo
	@echo "Read README file for detailed information."

iscsiuio/Makefile: iscsiuio/configure iscsiuio/Makefile.in
	cd iscsiuio; ./configure $(WITHOUT_ARG) --sbindir=$(SBINDIR)

iscsiuio/configure: iscsiuio/configure.ac iscsiuio/Makefile.am
	cd iscsiuio; autoreconf --install

force: ;

clean distclean:
	$(MAKE) $(MFLAGS) -C sysdeps $@
	$(MAKE) $(MFLAGS) -C utils $@
	$(MAKE) $(MFLAGS) -C usr $@
	$(MAKE) $(MFLAGS) -C etc $@
	$(MAKE) $(MFLAGS) -C libopeniscsiusr $@
	$(MAKE) $(MFLAGS) -C doc $@
	[ ! -f iscsiuio/Makefile ] || $(MAKE) $(MFLAGS) -C iscsiuio $@

# this is for safety
# now -jXXX will still be safe
# note that make may still execute the blocks in parallel
.NOTPARALLEL: install_user install_programs install_initd \
	install_initd_redhat install_initd_debian \
	install_doc install_iname install_etc install_etc_all

install: install_programs install_doc \
	install_systemd install_iname install_libopeniscsiusr \
	install_iscsiuio install_etc_all

install_iscsiuio:
	$(MAKE) $(MFLAGS) -C iscsiuio install

install_user: install_programs install_doc install_systemd install_iname

install_udev_rules:
	$(MAKE) $(MFLAGS) -C utils $@

install_programs:
	$(MAKE) $(MFLAGS) -C utils install
	$(MAKE) $(MFLAGS) -C usr install

install_initd install_initd_redhat install_initd_debian install_iface install_systemd install_etc install_iname:
	$(MAKE) $(MFLAGS) -C etc $@

install_etc_all:
	$(MAKE) $(MFLAGS) -C etc install

install_doc:
	$(MAKE) $(MFLAGS) -C doc $@

install_libopeniscsiusr:
	$(MAKE) $(MFLAGS) -C libopeniscsiusr install

depend:
	for dir in usr utils utils/fwparam_ibft sysdeps; do \
		$(MAKE) $(MFLAGS) -C $$dir $@; \
	done

.PHONY: all user install force clean install_user install_udev_rules install_systemd \
	install_programs install_initrd install_initrd_redhat install_initrd_debian \
	install_doc install_iname install_libopeniscsiusr install_etc install_etc_all \
	distclean depend install_initd install_initd_redhat install_initd_debian \
	install_iscsiuio

=== meson_options.txt ===
# options for meson build system
option('systemddir', type: 'string', value: '/usr/lib/systemd',
  description: 'Systemd directory [/usr/lib/systemd], if systemd used')
option('no_systemd', type: 'boolean', value: false,
  description: 'Do not use systemd')
option('source_date_epoch', type: 'string', value: 'NONE',
  description: 'Set the Build Source Date (for iscsiuio), for repeatable builds')
# these are in the 'sysconfigdir' (/etc by default) unless overridden
option('homedir', type: 'string', value: 'iscsi',
  description: 'Set the HOME directory [/etc/iscsi]')
option('dbroot', type: 'string', value: 'iscsi',
  description: 'Set the DATABASE root directory [/etc/iscsi]')
option('lockdir', type: 'string', value: '/run/lock/iscsi',
  description: 'Set the LOCK_DIR directory [/run/lock/iscsi]')
option('rulesdir', type: 'string', value: 'udev/rules.d',
  description: 'Set the directory where udev rules go [/etc/udev/rules.d]')
# to be able to put binaries in /sbin or /usr/sbin, since
# older version of meson do not allow overriding sbindir
option('iscsi_sbindir', type: 'string', value: '/usr/sbin',
  description: 'Set the directory where our binaries go [/usr/sbin]')

=== doc/Makefile ===
# This Makefile will work only with GNU make.
#
# Make file for the doc sub-directory
#

ifeq ($(TOPDIR),)
	TOPDIR = ..
endif

SED ?= sed
INSTALL = install

DESTDIR ?=
etcdir = /etc
DBROOT ?= $(etcdir)/iscsi
HOMEDIR ?= $(etcdir)/iscsi

prefix ?= /usr
mandir ?= $(prefix)/share/man

MAN8DIR = $(DESTDIR)$(mandir)/man8

MANPAGES_SOURCES	= iscsi_discovery.8 \
			  iscsi_fw_login.8 \
			  iscsi-iname.8
MANPAGES_TEMPLATES	= iscsid.8.template \
			  iscsiadm.8.template \
			  iscsi-gen-initiatorname.8 \
			  iscsistart.8.template
MANPAGES_GENERATED	= $(MANPAGES_TEMPLATES:.template=)
MANPAGES_DEST		= $(addprefix $(MAN8DIR)/,$(MANPAGES_GENERATED)) \
			  $(addprefix $(MAN8DIR)/,$(MANPAGES_SOURCES))

all: $(MANPAGES_GENERATED)

install: install_doc

install_doc: $(MAN8DIR) $(MANPAGES_DEST)

$(MANPAGES_GENERATED): %.8: %.8.template
	$(SED) -e 's:@HOMEDIR@:$(HOMEDIR):' -e 's:@DBROOT@:$(DBROOT):' $? > $@

$(MANPAGES_DEST): $(MAN8DIR)/%: %
	$(INSTALL) -m 644 $? $@


$(MAN8DIR):
	[ -d $@ ] || $(INSTALL) -d $@

clean: ;

distclean:
	$(RM) $(MANPAGES_GENERATED)

.PHONY: all install install_doc clean distclean

=== sysdeps/Makefile ===
# This Makefile will work only with GNU make.

CFLAGS ?= -O2 -fno-inline -g
CFLAGS += $(WARNFLAGS) -Wall -Wstrict-prototypes

SYSDEPS_OBJS=sysdeps.o

all: $(SYSDEPS_OBJS)

clean:
	$(RM) *.o .depend

distclean: ;

.PHONY: all clean distclean depend

depend:
	$(CC) $(CFLAGS) -M `ls *.c` > .depend

-include .depend

=== usr/Makefile ===
# This Makefile will work only with GNU make.

ifeq ($(TOPDIR),)
	TOPDIR = ..
endif

INSTALL = install

DESTDR ?=
SBINDIR ?= /sbin
etcdir = /etc

OSNAME=$(shell uname -s)

# allow users to override these
# eg to compile for a kernel that you aren't currently running
KERNELRELEASE ?= $(shell uname -r)
KSRC ?= /lib/modules/$(KERNELRELEASE)/build

KSUBLEVEL=$(shell cat $(KSRC)/Makefile | awk -F= '/^SUBLEVEL =/ {print $$2}' | \
			sed 's/^[ \t]*//;s/[ \t]*$$//')

ifeq ($(OSNAME),Linux)
	ifeq ($(KSUBLEVEL),11)
		IPC_CFLAGS=-DNETLINK_ISCSI=12 -D_GNU_SOURCE
	else
	ifeq ($(KSUBLEVEL),12)
		IPC_CFLAGS=-DNETLINK_ISCSI=12 -D_GNU_SOURCE
	else
		IPC_CFLAGS=-DNETLINK_ISCSI=8 -D_GNU_SOURCE
	endif
	endif
IPC_OBJ=netlink.o
else
ifeq ($(OSNAME),FreeBSD)
IPC_CFLAGS=
IPC_OBJ=ioctl.o
endif
endif

DBROOT ?= $(etcdir)/iscsi
HOMEDIR ?= $(etcdir)/iscsi

PKG_CONFIG ?= /usr/bin/pkg-config

CFLAGS ?= -O2 -g
WARNFLAGS ?= -Wall -Wextra -Werror -Wstrict-prototypes -fno-common
CFLAGS += $(WARNFLAGS) -I../include -I. -D_GNU_SOURCE \
	  -I$(TOPDIR)/libopeniscsiusr \
	  -DISCSI_VERSION_STR=\"$(ISCSI_VERSION_STR)\"
CFLAGS += $(shell $(PKG_CONFIG) --cflags libkmod)
CFLAGS += $(shell $(PKG_CONFIG) --cflags libsystemd)
ISCSI_LIB = -L$(TOPDIR)/libopeniscsiusr -lopeniscsiusr
LDFLAGS += $(shell $(PKG_CONFIG) --libs libkmod)
ifeq ($(NO_SYSTEMD),)
LDFLAGS += $(shell $(PKG_CONFIG) --libs libsystemd)
else
CFLAGS += -DNO_SYSTEMD
endif
CFLAGS += -DISCSI_DB_ROOT=\"$(DBROOT)\"
CFLAGS += -DISCSI_CONFIG_ROOT=\"$(HOMEDIR)\"

PROGRAMS	= iscsid iscsiadm iscsistart
PROGRAMS_DEST	= $(addprefix $(DESTDIR)$(SBINDIR)/,$(PROGRAMS))

ISCSID_OBJS	= iscsid.o session_mgmt.o discoveryd.o mntcheck.o
ISCSIADM_OBJS	= iscsiadm.o session_mgmt.o mntcheck.o
ISCSISTART_OBJS	= iscsistart.o

# libc compat files
SYSDEPS_DIR = $(TOPDIR)/sysdeps
SYSDEPS_OBJS = $(SYSDEPS_DIR)/sysdeps.o
# sources shared between iscsid, iscsiadm and iscsistart
ISCSI_LIB_OBJS = iscsi_util.o io.o auth.o iscsi_timer.o login.o log.o \
	iface.o idbm.o sysfs.o host.o session_info.o iscsi_sysfs.o \
	iscsi_net_util.o iscsid_req.o transport.o iser.o cxgbi.o be2iscsi.o \
	initiator_common.o iscsi_err.o flashnode.o uip_mgmt_ipc.o \
	netlink.o
# core initiator files
INITIATOR_OBJS = initiator.o scsi.o actor.o event_poll.o mgmt_ipc.o kern_err_table.o

# fw boot files
FW_BOOT_DIR = fwparam_ibft
FW_BOOT_OBJ_FILES = fw_entry.o fwparam_sysfs.o prom_lex.o prom_parse.tab.o fwparam_ppc.o
FW_BOOT_OBJS = $(addprefix $(FW_BOOT_DIR)/,$(FW_BOOT_OBJ_FILES))

# core discovery files
DISCOVERY_OBJS = local_strings.o discovery.o

all: $(PROGRAMS)

iscsid: $(ISCSI_LIB_OBJS) $(SYSDEPS_OBJS) $(INITIATOR_OBJS) $(DISCOVERY_OBJS) $(FW_BOOT_OBJS) \
	$(ISCSID_OBJS)
	$(CC) $(CFLAGS) $^ -o $@  -lisns -lcrypto -lrt -lmount $(LDFLAGS) $(ISCSI_LIB)

iscsiadm: $(ISCSI_LIB_OBJS) $(SYSDEPS_OBJS) $(DISCOVERY_OBJS) $(FW_BOOT_OBJS) \
	$(ISCSIADM_OBJS)
	$(CC) $(CFLAGS) $^ -o $@ -lisns -lcrypto -lmount $(LDFLAGS) $(ISCSI_LIB)

iscsistart: $(ISCSI_LIB_OBJS) $(SYSDEPS_OBJS) $(INITIATOR_OBJS) $(FW_BOOT_OBJS) \
	$(ISCSISTART_OBJS)
	$(CC) $(CFLAGS) $^ -o $@ -lcrypto -lrt $(LDFLAGS) $(ISCSI_LIB)

install: $(DESTDIR)$(SBINDIR) $(PROGRAMS_DEST)

$(DESTDIR)$(SBINDIR):
	[ -d $@ ] || $(INSTALL) -d $@

$(PROGRAMS_DEST): $(DESTDIR)$(SBINDIR)/%: %
	$(INSTALL) -m 755 $? $@

$(SYSDEPS_OBJS):
	$(MAKE) $(MFLAGS) -C $(SYSDEPS_DIR)

$(FW_BOOT_OBJS):
	$(MAKE) $(MFLAGS) -C $(FW_BOOT_DIR)

clean:
	$(RM) $(ISCSI_LIB_OBJS) $(INITIATOR_OBJS) $(DISCOVERY_OBJS) \
		$(ISCSISTART_OBJS) $(ISCSID_OBJS) $(ISCSIADM_OBJS) \
		$(PROGRAMS) .depend
	$(MAKE) $(MFLAGS) -C $(FW_BOOT_DIR) clean

distclean: ;

.PHONY: all install clean distclean depend

depend:
	$(CC) $(CFLAGS) -M `ls *.c` > .depend
	$(MAKE) $(MFLAGS) -C $(FW_BOOT_DIR) depend

-include .depend

=== utils/Makefile ===
# This Makefile will work only with GNU make.
#
# Make file for the util sub-directory
#
# This make file does not control the sysdeps
# subdirectory, which is controlled
# from the top-level make file.
#

SED ?= sed
INSTALL = install
CHMOD = chmod

DESTDIR ?=
SBINDIR ?= /sbin
etcdir = /etc
HOMEDIR ?= $(etcdir)/iscsi

RULESDIR ?= $(etcdir)/udev/rules.d

CFLAGS ?= -O2 -fno-inline -g
CFLAGS += -Wall -Wextra -Wstrict-prototypes

PROGRAMS	= iscsi-iname
PROGRAMS_DEST	= $(addprefix $(DESTDIR)$(SBINDIR)/,$(PROGRAMS))

SCRIPTS_SOURCES		= iscsi_discovery.sh iscsi_offload.sh
SCRIPTS_TEMPLATES	= iscsi_fw_login.sh.template iscsi-gen-initiatorname.sh.template
SCRIPTS_GENERATED	= $(SCRIPTS_TEMPLATES:.template=)
SCRIPTS_DEST		= $(addprefix $(DESTDIR)$(SBINDIR)/,$(basename $(SCRIPTS_GENERATED))) \
			  $(addprefix $(DESTDIR)$(SBINDIR)/,$(basename $(SCRIPTS_SOURCES)))

RULESFILES_TEMPLATES	= 50-iscsi-firmware-login.rules.template
RULESFILES_GENERATED	= $(RULESFILES_TEMPLATES:.template=)
RULESFILES_DEST		= $(addprefix $(DESTDIR)$(RULESDIR)/,$(RULESFILES_GENERATED))

OBJS = iscsi-iname.o md5.o

all: $(PROGRAMS) $(SCRIPTS_GENERATED) $(RULESFILES_GENERATED)

$(SCRIPTS_GENERATED): %.sh: %.sh.template
	$(SED) -e 's:@SBINDIR@:$(SBINDIR):' -e 's:@HOMEDIR@:$(HOMEDIR):' $? > $@
	$(CHMOD) 755 $@

$(RULESFILES_GENERATED): %.rules: %.rules.template
	$(SED) -e 's:@SBINDIR@:$(SBINDIR):' $? > $@

iscsi-iname: $(OBJS)
	$(CC) $(CFLAGS) $(LDFLAGS) $^ $(DBM_LIB) -o $@

install: $(DESTDIR)$(SBINDIR) $(DESTDIR)$(RULESDIR) \
	$(PROGRAMS_DEST) $(SCRIPTS_DEST) $(RULESFILES_DEST)

$(PROGRAMS_DEST): $(DESTDIR)$(SBINDIR)/%: %
	$(INSTALL) -m 755 $? $@

$(SCRIPTS_DEST): $(DESTDIR)$(SBINDIR)/%: %.sh
	$(INSTALL) -m 755 $? $@

install_udev_rules: $(RULESFILES_DEST)

$(RULESFILES_DEST): $(DESTDIR)$(RULESDIR)/%: %
	$(INSTALL) -m 644 $? $@

$(DESTDIR)$(SBINDIR) $(DESTDIR)$(RULESDIR):
	[ -d $@ ] || $(INSTALL) -d $@

clean:
	$(RM) $(OBJS)
	$(RM) $(PROGRAMS)
	$(RM) .depend

distclean:
	$(RM) $(SCRIPTS_GENERATED)
	$(RM) $(RULESFILES_GENERATED)

.PHONY: all install clean distclean depend install_udev_rules

depend:
	$(CC) $(CFLAGS) -M `ls *.c` > .depend

-include .depend

=== usr/fwparam_ibft/Makefile ===
#
#  Copyright (C) IBM Corporation. 2007
#  Author: Doug Maxey <dwm@austin.ibm.com>
#
#  This program is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
#  Authors: Patrick Mansfield <patmans@us.ibm.com>
#	    Mike Anderson <andmike@us.ibm.com>
#	    Doug Maxey <dwm@austin.ibm.com>
#	    "Prasanna Mumbai" <mumbai.prasanna@gmail.com>
#
ifeq ($(TOPDIR),)
	TOPDIR = ../..
endif

BISON = bison

SBINDIR ?= $(DESTDIR)/sbin

SYSDEPS_OBJS = $(sort $(wildcard ../sysdeps/*.o))
OBJS := fw_entry.o fwparam_sysfs.o \
	prom_lex.o prom_parse.tab.o fwparam_ppc.o
CLEANFILES = $(OBJS) *.output

CFLAGS ?= -O2 -g
WARNFLAGS ?= -Wall -Wstrict-prototypes -Wno-format-truncation
CFLAGS += -fPIC $(WARNFLAGS) -I$(TOPDIR)/include -I$(TOPDIR)/usr -D_GNU_SOURCE \
	  -I$(TOPDIR)/libopeniscsiusr
CFLAGS += -DSBINDIR=\"$(SBINDIR)\" \
	  -DISCSI_VERSION_STR=\"$(ISCSI_VERSION_STR)\"

all: $(OBJS)

clean:
	$(RM) $(CLEANFILES) .depend

$(OBJS): prom_parse.tab.h prom_parse.h

#
# This directory is set up so that lex and bison should not have
# to be run to generate C files, since the C files have already
# been checked in and are present. This eliminates the need to run
# them on systems where those tools may not be present. If you wish
# to run either of them to regenerate their output files, remove
# the output files first. This prevents these tools from being run
# again if the output files are already present.
#

prom_lex.c: prom_lex.l
	@[ -f $@ ] || $(LEX) -t $? > $@

prom_parse.tab.c prom_parse.tab.h: prom_parse.y
	@[ -f prom_parse.tab.c ] && [ -f prom_parse.tab.h ] || $(BISON) -H $?

depend:
	$(CC) $(CFLAGS) -M `ls *.c` > .depend

-include .depend

=== debian/changelog ===
open-iscsi (2.1.8-1ubuntu2) mantic; urgency=medium

  * Fix format overflow warnings seen when building with
    -O3 to avoid FTBFS on ppc64el (LP: #2036884)

 -- Graham Inggs <ginggs@ubuntu.com>  Fri, 22 Sep 2023 15:42:55 +0000

open-iscsi (2.1.8-1ubuntu1) lunar; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - debian/tests: Add Ubuntu autopkgtest suite:
      + d/t/README-boot-test.md: document test design
      + d/t/control: register testsuite
      + d/t/get-image: helper to fetch an ubuntu cloud image
      + d/t/patch-image: helper to modify an ubuntu cloud image
      + d/test-open-iscsi.py, d/t/testlib.py: various qa regression tests
      + d/t/testsuite: helper to invoke qa regression tests
      + d/t/tgt-boot-test: test using tgt to boot from iscsi
      + d/t/xkvm: helper to spawn a VM
    - d/README.Debian, d/extra/startup-checks.sh, d/open-iscsi.postinst:
      Apply Ubuntu branding to iqn initiator name

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 07 Nov 2022 15:10:10 -0800

open-iscsi (2.1.8-1) unstable; urgency=medium

  [ Chris Hofstaedtler ]
  * [be2751b] New upstream version 2.1.8 (Closes: #1021742)
  * [6697df5] Remove upstream applied non-usrmerge-sed.patch

  [ Eric Mackay ]
  * [7dbf2c1] Man pages are no longer gzipped in upstream code
  * [833e478] Drop upstream 341 and 354 patches, refresh remaining patches

 -- Chris Hofstaedtler <zeha@debian.org>  Wed, 19 Oct 2022 15:59:32 +0000

=== debian/control ===
Source: open-iscsi
Section: net
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian iSCSI Maintainers <open-iscsi@packages.debian.org>
Uploaders: Ritesh Raj Sarraf <rrs@debian.org>,
           Christian Seiler <christian@iwakd.de>,
           Chris Hofstaedtler <zeha@debian.org>
Build-Depends: bison,
               bzip2,
               debhelper-compat (= 13),
               dh-exec,
               dpkg-dev (>= 1.19),
               flex,
               libisns-dev,
               libmount-dev,
               pkg-config,
               libkmod-dev,
               libsystemd-dev,
               libssl-dev
Standards-Version: 4.5.1
Vcs-Git: https://salsa.debian.org/linux-blocks-team/open-iscsi.git
Vcs-Browser: https://salsa.debian.org/linux-blocks-team/open-iscsi
Homepage: https://www.open-iscsi.com/
Rules-Requires-Root: no

Package: open-iscsi
Architecture: linux-any
Multi-Arch: foreign
Depends: ${misc:Depends},
         ${shlibs:Depends},
         libopeniscsiusr,
         udev
Recommends: ${busybox:Recommends}, finalrd (>= 3)
Pre-Depends: debconf | debconf-2.0
Description: iSCSI initiator tools
 The Open-iSCSI project is a high-performance, transport independent,
 multi-platform implementation of RFC3720 iSCSI.
 .
 Open-iSCSI is partitioned into user and kernel parts.
 .
 The kernel portion of Open-iSCSI is a from-scratch code
 licensed under GPL. The kernel part implements iSCSI data path
 (that is, iSCSI Read and iSCSI Write), and consists of three
 loadable modules: scsi_transport_iscsi.ko, libiscsi.ko and iscsi_tcp.ko.
 .
 User space contains the entire control plane: configuration
 manager, iSCSI Discovery, Login and Logout processing,
 connection-level error processing, Nop-In and Nop-Out handling,
 and (in the future:) Text processing, iSNS, SLP, Radius, etc.
 .
 The user space Open-iSCSI consists of a daemon process called
 iscsid, and a management utility iscsiadm.
 .
 This package includes a daemon, iscsid, and a management utility,
 iscsiadm.

Package: libopeniscsiusr
Architecture: linux-any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Enhances: open-iscsi
Description: iSCSI userspace library
 The Open-iSCSI project is a high-performance, transport independent,
 multi-platform implementation of RFC3720 iSCSI.
 .
 Open-iSCSI is partitioned into user and kernel parts.
 .
 The kernel portion of Open-iSCSI is a from-scratch code
 licensed under GPL. The kernel part implements iSCSI data path
 (that is, iSCSI Read and iSCSI Write), and consists of three
 loadable modules: scsi_transport_iscsi.ko, libiscsi.ko and iscsi_tcp.ko.
 .
 User space contains the entire control plane: configuration
 manager, iSCSI Discovery, Login and Logout processing,
 connection-level error processing, Nop-In and Nop-Out handling,
 and (in the future:) Text processing, iSNS, SLP, Radius, etc.
 .
 The user space Open-iSCSI consists of a daemon process called
 iscsid, and a management utility iscsiadm.
 .
 This package contains the iSCSI userspace library.

Package: libopeniscsiusr-dev
Architecture: all
Depends: ${misc:Depends},
         libopeniscsiusr
Enhances: open-iscsi
Description: iSCSI userspace library headers
 The Open-iSCSI project is a high-performance, transport independent,
 multi-platform implementation of RFC3720 iSCSI.
 .
 Open-iSCSI is partitioned into user and kernel parts.
 .
 The kernel portion of Open-iSCSI is a from-scratch code
 licensed under GPL. The kernel part implements iSCSI data path
 (that is, iSCSI Read and iSCSI Write), and consists of three
 loadable modules: scsi_transport_iscsi.ko, libiscsi.ko and iscsi_tcp.ko.
 .
 User space contains the entire control plane: configuration
 manager, iSCSI Discovery, Login and Logout processing,
 connection-level error processing, Nop-In and Nop-Out handling,
 and (in the future:) Text processing, iSNS, SLP, Radius, etc.
 .
 The user space Open-iSCSI consists of a daemon process called
 iscsid, and a management utility iscsiadm.
 .
 This package contains the iSCSI userspace library headers.

Package: iscsiuio
Architecture: linux-any
Multi-Arch: foreign
Depends: ${misc:Depends},
         ${shlibs:Depends},
         libopeniscsiusr,
         udev
Enhances: open-iscsi
Description: iSCSI offloading daemon for QLogic devices
 The Open-iSCSI project is a high-performance, transport independent,
 multi-platform implementation of RFC3720 iSCSI.
 .
 This tool is to be used in conjunction with the QLogic NetXtreme II Linux
 driver (Kernel module name: 'bnx2' and 'bnx2x'), QLogic CNIC driver,
 and the QLogic iSCSI driver (Kernel module name: 'bnx2i').
 .
 This user space tool is used in conjunction with the following
 QLogic Network Controllers:
   bnx2:  BCM5706, BCM5708, BCM5709 devices
   bnx2x: BCM57710, BCM57711, BCM57711E, BCM57712, BCM57712E,
          BCM57800, BCM57810, BCM57840 devices
 .
 This utility will provide the ARP and DHCP functionality for the iSCSI
 offload. The communication to the driver is done via Userspace I/O (Kernel
 module name 'uio').
 .
 This package is required to offload iSCSI onto these devices.

Package: open-iscsi-udeb
# Note: the (virtual) udeb package scsi-modules (provided by different
#       linux kernel udebs) must exist for these architectures - so
#       check that before adding them to this list; the other
#       scsi-(core|common|...)-modules are NOT sufficient!
Architecture: amd64 arm64 armhf i386 ia64 mips mipsel powerpc ppc64 ppc64el s390x
Section: debian-installer
Package-Type: udeb
Depends: ${misc:Depends},
         ${shlibs:Depends},
         scsi-modules
Description: Configure iSCSI
 The Open-iSCSI project is a high-performance, transport independent,
 multi-platform implementation of RFC3720 iSCSI.
 .
 This is the minimal package (udeb) used by debian-installer.
